PREC		EQU	8

model		small,C
.386

.data


.code

public		scan_convert

scan_convert	proc	points,pnum,xbuf,txbuf,tybuf,lightbuf,miny,maxy:WORD

local		prev_x,prev_y,prev_tx,prev_ty,prev_l,y_diff,vec_offset,min,max:WORD

		push	si di
		cld
		mov	si,[points]
		mov	ax,10
		mul	word ptr [pnum]
		mov	bx,ax
		add	bx,si
		mov	cx,[bx-10]
		mov	[prev_x],cx
		mov	cx,[bx-8]
		mov	[prev_y],cx
		mov	[min],cx
		mov	[max],cx
		mov	cx,[bx-6]
		mov	[prev_tx],cx
		mov	cx,[bx-4]
		mov	[prev_ty],cx
		mov	cx,[bx-2]
		mov	[prev_l],cx

next_line:	movzx	eax,word ptr [si+2]		; EAX=Y1
		movzx	ebx,word ptr [prev_y]		; EBX=Y
		mov	[prev_y],ax
		cmp	ax,[min]
		jae	not_min
		mov	[min],ax
		jmp	min_max_done
not_min:	cmp	ax,[max]
		jbe	min_max_done
		mov	[max],ax
min_max_done:	cmp	bx,ax
		jz	horiz
		ja	upward

		sub	eax,ebx				; Downward
;		inc	ax
		mov	[y_diff],ax
		shl	bx,2
		mov	[vec_offset],bx

		movzx	eax,word ptr [si]		; EAX=X1
		movzx	ebx,word ptr [prev_x]		; EBX=X
		mov	[prev_x],ax
		mov	di,[vec_offset]	
		add	di,[xbuf]			; DI=&XBUF[Y][0]
		movzx	ecx,[y_diff]
		sub	eax,ebx				; EAX=X1-X
		sal	eax,PREC
		cdq
		idiv	ecx				; EAX=(X1-X)<<PREC/(Y1-Y)
		inc	cx
		sal	ebx,PREC
x_loop:		mov	edx,ebx
		shr	edx,PREC
		mov	[di],dx
		add	di,4
		add	ebx,eax
		dec	cx
		jnz	x_loop

		movzx	eax,word ptr [si+4]		; EAX=Texture X1
		movzx	ebx,word ptr [prev_tx]		; EBX=Texture X
		mov	[prev_tx],ax
		mov	di,[vec_offset]
		add	di,[txbuf]			; DI=&TXBUF[Y][0]
		movzx	ecx,[y_diff]
		sub	eax,ebx				; EAX=TX1-TX
		sal	eax,PREC
		cdq
		idiv	ecx				; EAX=(TX1-TX)<<PREC/(Y1-Y)
		inc	cx
		shl	ebx,PREC
tx_loop:	mov	edx,ebx
		shr	edx,PREC
		mov	[di],dx
		add	di,4
		add	ebx,eax
		dec	cx
		jnz	tx_loop

		movzx	eax,word ptr [si+6]		; EAX=Texture Y1
		movzx	ebx,word ptr [prev_ty]		; EBX=Texture Y
		mov	[prev_ty],ax
		mov	di,[vec_offset]
		add	di,[tybuf]			; DI=&TYBUF[Y][0]
		movzx	ecx,[y_diff]
		sub	eax,ebx				; EAX=TY1-Y
		sal	eax,PREC
		cdq
		idiv	ecx				; EAX=(TY1-TY)<<PREC/(Y1-Y)
		inc	cx
		shl	ebx,PREC
ty_loop:	mov	edx,ebx
		shr	edx,PREC
		mov	[di],dx
		add	di,4
		add	ebx,eax
		dec	cx
		jnz	ty_loop

		movzx	eax,word ptr [si+8]
		movzx	ebx,word ptr [prev_l]
		mov	[prev_l],ax
		mov	di,[vec_offset]
		add	di,[lightbuf]
		movzx	ecx,[y_diff]
		sub	eax,ebx
		sal	eax,PREC
		cdq
		idiv	ecx
		inc	cx
		shl	ebx,PREC
l_loop:		mov	edx,ebx
		shr	edx,PREC
		mov	[di],dx
		add	di,4
		add	ebx,eax
		dec	cx
		jnz	l_loop
		add	si,10
		dec	word ptr [pnum]
		jnz	next_line
		jmp	done

upward:		mov	cx,bx
		shl	cx,2
		add	cx,2
		mov	[vec_offset],cx
		sub	ebx,eax
;		inc	bx
		mov	[y_diff],bx

		movzx	eax,word ptr [si]		; EAX=X1
		movzx	ebx,word ptr [prev_x]		; EBX=X
		mov	[prev_x],ax
		mov	di,[vec_offset]	
		add	di,[xbuf]			; DI=&XBUF[Y][1]
		movzx	ecx,[y_diff]
		sub	eax,ebx				; EAX=X1-X
		sal	eax,PREC
		cdq
		idiv	ecx				; EAX=(X1-X)<<PREC/(Y1-Y)
		inc	cx
		sal	ebx,PREC
ux_loop:	mov	edx,ebx
		shr	edx,PREC
		mov	[di],dx
		sub	di,4
		add	ebx,eax
		dec	cx
		jnz	ux_loop

		movzx	eax,word ptr [si+4]		; EAX=Texture X1
		movzx	ebx,word ptr [prev_tx]		; EBX=Texture X
		mov	[prev_tx],ax
		mov	di,[vec_offset]
		add	di,[txbuf]			; DI=&TXBUF[Y][1]
		movzx	ecx,[y_diff]
		sub	eax,ebx				; EAX=TX1-TX
		sal	eax,PREC
		cdq
		idiv	ecx				; EAX=(TX1-TX)<<PREC/(Y1-Y)
		inc	cx
		shl	ebx,PREC
utx_loop:	mov	edx,ebx
		shr	edx,PREC
		mov	[di],dx
		sub	di,4
		add	ebx,eax
		dec	cx
		jnz	utx_loop

		movzx	eax,word ptr [si+6]		; EAX=Texture Y1
		movzx	ebx,word ptr [prev_ty]		; EBX=Texture Y
		mov	[prev_ty],ax
		mov	di,[vec_offset]
		add	di,[tybuf]			; DI=&TYBUF[Y][1]
		movzx	ecx,[y_diff]
		sub	eax,ebx				; EAX=TY1-Y
		sal	eax,PREC
		cdq
		idiv	ecx				; EAX=(TY1-TY)<<PREC/(Y1-Y)
		inc	cx
		shl	ebx,PREC
uty_loop:	mov	edx,ebx
		shr	edx,PREC
		mov	[di],dx
		sub	di,4
		add	ebx,eax
		dec	cx
		jnz	uty_loop

		movzx	eax,word ptr [si+8]
		movzx	ebx,word ptr [prev_l]
		mov	[prev_l],ax
		mov	di,[vec_offset]
		add	di,[lightbuf]
		movzx	ecx,[y_diff]
		sub	eax,ebx
		sal	eax,PREC
		cdq
		idiv	ecx
		inc	cx
		shl	ebx,PREC
ul_loop:	mov	edx,ebx
		shr	edx,PREC
		mov	[di],dx
		sub	di,4
		add	ebx,eax
		dec	cx
		jnz	ul_loop
		add	si,10
		dec	word ptr [pnum]
		jnz	next_line
		jmp	done

horiz:		shl	bx,2
		mov	di,[xbuf]
		mov	cx,[prev_x]
		mov	[bx+di],cx
		mov	cx,[si]
		mov	[prev_x],cx
		mov	di,[txbuf]
		mov	cx,[prev_tx]
		mov	[bx+di],cx
		mov	cx,[si+4]
		mov	[prev_tx],cx
		mov	di,[tybuf]
		mov	cx,[prev_ty]
		mov	[bx+di],cx
		mov	cx,[si+6]
		mov	[prev_ty],cx
		mov	di,[lightbuf]
		mov	cx,[prev_l]
		mov	[bx+di],cx
		mov	cx,[si+8]
		mov	[prev_l],cx
		add	si,10
		dec	word ptr [pnum]
		jnz	next_line

done:		mov	di,[miny]
		mov	cx,[min]
		mov	[di],cx
		mov	di,[maxy]
		mov	cx,[max]
		mov	[di],cx
		pop	di si
		ret

scan_convert	endp

end